% This code is used for the dG calculations performed in the article titled
% "Impact of Primer Dimers and Self-Amplifying Hairpins on Reverse Transcription
% Loop-Mediated Isothermal Amplification Detection of Viral RNA"
% Authors: Robert J. Meagher1 *, Aashish Priye1, Yooli K. Light2 Cheng Huang3, Eryu Wang4
% Code: Aashish Priye (apriye@sandia.gov)
% This program computes for dG(NSA)

% Nearest Neighbour stability matrix
% 
% AA  -7900.0  -22.2
% AC  -8400.0  -22.4
% AG  -7800.0  -21.0
% AT  -7200.0  -20.4
% CA  -8500.0  -22.7
% CC  -8000.0  -19.9
% CG -10600.0  -27.2
% CT  -7800.0  -21.0
% GA  -8200.0  -22.2
% GC  -9800.0  -24.4
% GG  -8000.0  -19.9
% GT  -8400.0  -22.4
% TA  -7200.0  -21.3
% TC  -8200.0  -22.2 
% TG  -8500.0  -22.7
% TT  -7900.0  -22.2
% IA   2300.0    4.1
% IG    100.0   -2.8
% 
% REF: Allawi and SantaLucia (1997). Biochemistry 36 : 10581-10594

[num,c_file_output_results,raw] = xlsread('get_results.xlsx'); %import_data from c file
p1_G_sum_hairpins = c_file_output(4); %contribution of dG due to hairpins
p1_G_sum_self_dimer = c_file_output(5); %contribution of dG due to self dimer
p2_G_sum_hairpins = c_file_output(6); %contribution of dG due to hairpins
p2_G_sum_self_dimer = c_file_output(7); %contribution of dG due to self dimer
p3_G_sum_hairpins = c_file_output(8); %contribution of dG due to hairpins
p3_G_sum_self_dimer = c_file_output(9); %contribution of dG due to self dimer
p4_G_sum_hairpins = c_file_output(10); %contribution of dG due to hairpins
p4_G_sum_self_dimer = c_file_output(11); %contribution of dG due to self dimer
p5_G_sum_hairpins = c_file_output(12); %contribution of dG due to hairpins
p5_G_sum_self_dimer = c_file_output(13); %contribution of dG due to self dimer
p6_G_sum_hairpins = c_file_output(14); %contribution of dG due to hairpins
p6_G_sum_self_dimer = c_file_output(15); %contribution of dG due to self dimer
G_cross_interaction_term = c_file_output(16); %contribution of dG due to cross interaction
G_perfect_binding_max = c_file_output(17); %max dG bue complimentary annealing of primer

dG_NSA_single = p1_G_sum_hairpins + p1_G_sum_self_dimer;
dG_NSA_global = p1_G_sum_hairpins + p1_G_sum_self_dimer + p2_G_sum_hairpins + p2_G_sum_self_dimer + p3_G_sum_hairpins + p3_G_sum_self_dimer+ p4_G_sum_hairpins + p4_G_sum_self_dimer+ p5_G_sum_hairpins + p5_G_sum_self_dimer+ p6_G_sum_hairpins + p6_G_sum_self_dimer + G_cross_interaction_term;
dG_NSA_single_norm =  dG_NSA_single/G_perfect_binding_max;
dG_NSA_global_norm =  dG_NSA_global/G_perfect_binding_max;













