#include "complot.h"

#if (defined(HAVE_LIBGD) || defined(HAVE_GDIMAGECREATE)) && defined(HAVE_GD_H)
#include "strings_img.h"
#endif

char img_filename[130];

int color_bk, color_gy, color_s1, color_s2, color_s3, color_s4, color_s5;
int color_co, color_tx, color_gd, color_lb, color_bg, color_cl;
extern int color_ann[];
int* const img_color[] = {&color_bk, &color_gy, &color_s1, &color_s2, 
			  &color_s3, &color_s4, &color_s5, &color_co, 
			  &color_tx, &color_gd, &color_lb, &color_bg, 
			  &color_cl};

/* img_creation */

/* convert a row to a position in pixels down from the top */
int img_row_to_y(int dis_t,int y_start,float y_pic_per_dot,int row) { 
   return y_start+(int)(y_pic_per_dot*((float)(row-dis_t))+.500001);
}
/* convert a column to position in pixels right from the left edge */
int img_col_to_x(int dis_l,int x_start,float x_pic_per_dot,int column) {
  return x_start+(int)(x_pic_per_dot*((float)(column-dis_l))+.50001);
}


/* draw a single dot */
void img_plot_dot(int x_start, int y_start , float x_pic_per_dot,
		  float y_pic_per_dot, int dis_l, int dis_t,
		  int color, int row, int column) {
  int x_pos; /* positions for center of dot */
  int y_pos;
  int ix_dot_size,iy_dot_size;
  float scale_adjust_x,scale_adjust_y; /* make large dots smaller */
  /* make small dots larger */
  int lx,rx,ty,by; /* positions for corners of dot */
  x_pos=img_col_to_x(dis_l,x_start,x_pic_per_dot,column);
  y_pos=img_row_to_y(dis_t,y_start,y_pic_per_dot,row);
  if((x_pic_per_dot<1.2)||(y_pic_per_dot<1.2)) { /* draw a dot here */
    gdImageSetPixel(image, x_pos, y_pos, color);
  } else { /* draw a rectangle here 94% of the proper width */
    if(x_pic_per_dot>3.)
      scale_adjust_x=.85;
    else
      scale_adjust_x=1;
    if(y_pic_per_dot>3.)
      scale_adjust_y=.80; /* make big dots smaller */
    else
      scale_adjust_y=1.1; /* make small dots bigger */
    ix_dot_size=(int)(x_pic_per_dot*scale_adjust_x+.7);
    if(ix_dot_size<1)
      ix_dot_size=1;
    iy_dot_size=(int)(y_pic_per_dot*scale_adjust_y+.7);
    if(iy_dot_size<1)
        iy_dot_size=1;
      lx=x_pos-ix_dot_size/2;
      rx=lx+ix_dot_size-1;
      ty=y_pos-iy_dot_size/2;
      by=ty+iy_dot_size-1;
      gdImageFilledRectangle(image, lx, ty, rx, by, color);
  } 
}

/* create the tic marks */
void img_single_hor_tic(int x_start,int j_col,float x_pic_per_dot,int ty,
                        int by,int dis_l,int grid_flag) {
  int x_pos;
  x_pos=img_col_to_x(dis_l,x_start,x_pic_per_dot,j_col);
  if(grid_flag==TRUE)
    gdImageLine(image, x_pos, ty, x_pos, by - 2, color_gd);
  gdImageLine(image, x_pos, ty, x_pos, ty - 15, color_tx);
  gdImagePrintf(image, gdFontLarge, x_pos - 10, ty - 36, color_tx, "%d", 
		j_col);
}

void img_plot_hor_tics(int x_start,float x_pic_per_dot,int dis_l,
                       int dis_r,int ty,int by,int grid_flag) { 
  int j_col,step;
  int start;
  step=step_fun(dis_l,dis_r);
  start=start_fun(dis_l,step);
  img_single_hor_tic(x_start,dis_l,x_pic_per_dot,ty,by,dis_l,FALSE);
  img_single_hor_tic(x_start,dis_r,x_pic_per_dot,ty,by,dis_l,FALSE);
  for(j_col=start;j_col<(dis_r-2*step/3); j_col=j_col+step) {
    img_single_hor_tic(x_start, j_col, x_pic_per_dot, ty,by, dis_l, grid_flag);
  }
}

void img_single_ver_tic(int y_start,int i_row,float y_pic_per_dot,
			int lx,int rx,int dis_t,int grid_flag) {
  int y_pos; 
  y_pos=img_row_to_y(dis_t,y_start,y_pic_per_dot,i_row);
  if(grid_flag==TRUE)
    gdImageLine(image, rx - 2, y_pos, lx + 2, y_pos, color_gd);
  gdImageLine(image, rx, y_pos, rx + 15, y_pos, color_tx);
  gdImagePrintf(image, gdFontLarge, rx + 18, y_pos-12, color_tx, "%d", i_row);
}

void img_plot_ver_tics(int y_start,float y_pic_per_dot,int dis_t,
                       int dis_b,int lx,int rx,int grid_flag) {
  int i_row,step,start;
  step = step_fun(dis_t,dis_b);
  start = start_fun(dis_t,step);
  img_single_ver_tic(y_start,dis_t,y_pic_per_dot,lx,rx,dis_t,FALSE);
  img_single_ver_tic(y_start,dis_b,y_pic_per_dot,lx,rx,dis_t,FALSE);
  for(i_row = start;i_row<(dis_b-step/2);i_row=i_row+step) {
    img_single_ver_tic(y_start, i_row, y_pic_per_dot,lx,rx, dis_t, grid_flag);
  }
}

void  img_tics(int x_start, int y_start, float x_pic_per_dot, 
	       float y_pic_per_dot, int dis_l, int dis_r, int dis_t,
	       int dis_b, int lx, int rx, int ty, int by, int grid_flag) {
  img_plot_ver_tics(y_start,y_pic_per_dot,dis_t,dis_b,lx,rx,grid_flag);
  img_plot_hor_tics(x_start,x_pic_per_dot,dis_l,dis_r,ty,by,grid_flag);
}

void img_points_comp(int x_start, int y_start, float x_pic_per_dot,
		     float y_pic_per_dot, int disp_l, int disp_r, int disp_t,
		     int disp_b, int *diag_start, int *diag_count,
		     struct helix *l_diag, int dot_lower_flag) {
  int row,column,new_row,count;
  int diag,position,location,new_color;
  int color;
  int start_diag,end_diag;
  int dis_l,dis_r,dis_t,dis_b;
  if(dot_lower_flag) {
    dis_l=disp_t;
    dis_r=disp_b;
    dis_t=disp_l;
    dis_b=disp_r;
  } else {
    dis_t=disp_t;
    dis_b=disp_b;
    dis_l=disp_l;
    dis_r=disp_r;
  }
  start_diag=dis_l+dis_t-1;
  end_diag=dis_r+dis_b-1;
  color=0;
  for(diag=start_diag;diag<=end_diag;diag++) {
    position=diag_start[diag];
    for(count=0;count<diag_count[diag];count++) {
      location=position+count;
      new_color=l_diag[location].color;
      if(new_color==color) {
	new_row=l_diag[location].row;
	column=l_diag[location].column;
	for(row=new_row; row<(new_row+l_diag[location].length); row++) {
	  if((row>=dis_t)&&(row<=dis_b)&&(column>=dis_l)&&(column<= dis_r)) {
	    if(check_compensate(row,column)) {
	      if(dot_lower_flag)
		img_plot_dot(x_start, y_start, x_pic_per_dot, y_pic_per_dot,
			     dis_t, dis_l, color_co, column,row);
	      else
		img_plot_dot(x_start, y_start, x_pic_per_dot, y_pic_per_dot,
			     dis_l, dis_t, color_co, row, column);
	    }
	  }
	  column--;
	}
      }                        
    }
  }
}

void img_points_close(int x_start, int y_start, float x_pic_per_dot,
		      float y_pic_per_dot, int dis_l, int dis_r, int dis_t,
		      int dis_b, int count_nearby, 
		      struct basepair *nearby_basepair) {
  /* plot the dots with the close distance specified */
  int i,row,col;
  for(i=0;i<count_nearby;i++) {
    row = nearby_basepair[i].row;
     col = nearby_basepair[i].column;
     if((row>=dis_t) && (row<=dis_b) && (col>=dis_l) && (col<=dis_r)) {
       img_plot_dot(x_start, y_start, x_pic_per_dot, y_pic_per_dot, dis_l,
		    dis_t, *img_color[COLOR_CLOSE],row,col);
     }
     /* lower triangle */
     if((col>=dis_t) && (col<=dis_b) && (row>=dis_l) && (row<=dis_r)) {
       img_plot_dot(x_start, y_start, x_pic_per_dot, y_pic_per_dot,
		    dis_l, dis_t, *img_color[COLOR_CLOSE], col, row);
     }
  }
}

int get_ann_color(int, int);

void img_points(int x_start, int y_start, float x_pic_per_dot, 
		float y_pic_per_dot, int disp_l, int disp_r, int disp_t,
		int disp_b, int *diag_start, int *diag_count, int count_nearby,
		int unique_mode, struct helix *l_diag, 
		struct basepair *nearby_basepair, int last_used_sequence,
		int comp_flag, int sequence_length, int no_partial_flag,
		int annotation_flag, int prob_annotation_flag,
		int dot_lower_flag) {
  int row, column, new_row, count, diag, position, location, new_color;
  int color, start_diag, end_diag, *holder, size, ann_color, color_index;
  int dis_l, dis_r, dis_t, dis_b;
 if(dot_lower_flag) {
   dis_l = disp_t;
   dis_r = disp_b;
   dis_t = disp_l;
   dis_b = disp_r;
 } else {
   dis_t = disp_t;
   dis_b = disp_b;
   dis_l = disp_l;
   dis_r = disp_r;
 }
 start_diag = dis_l+dis_t-1;
 end_diag = dis_b+dis_r-1;
 if(!unique_mode) {
   for(color=last_used_sequence;color>=0;color--) {
     if((color==1) && (count_nearby>0))
       img_points_close(x_start, y_start, x_pic_per_dot, y_pic_per_dot,
			disp_l, disp_r, disp_t, disp_b, count_nearby,
                        nearby_basepair);
     for(diag=start_diag;diag<=end_diag;diag++) {
       position=diag_start[diag];
       for(count=0;count<diag_count[diag];count++) {
	 location=position+count;
	 new_color=l_diag[location].color;
	 if(new_color==color) {
	   new_row = l_diag[location].row;
	   column = l_diag[location].column;
	   for(row=new_row; row<(new_row+l_diag[location].length); row++) {
	     if((row>=dis_t) && (row<=dis_b) && (column>=dis_l)
		&& (column<= dis_r)) {
	       if(dot_lower_flag) 
		 img_plot_dot(x_start, y_start, x_pic_per_dot, y_pic_per_dot,
			      dis_t, dis_l, *img_color[color], column,row);
	       else
		 img_plot_dot(x_start, y_start, x_pic_per_dot, y_pic_per_dot,
			      dis_l, dis_t, *img_color[color], row, column);
	     }
	     column--;
	   }
	 }                        
       }
     }
   }
 } 
 if((comp_flag) && (!unique_mode))
   img_points_comp(x_start, y_start, x_pic_per_dot, y_pic_per_dot, disp_l,
		   disp_r, disp_t, disp_b, diag_start, diag_count, l_diag,
		   dot_lower_flag); /* draw lower triangle */
 for(color=1;color>=0;color--) {
   if(no_partial_flag)
     color=0;
   color_index = *img_color[color];
   for(diag=start_diag;diag<=end_diag;diag++) {
     position=diag_start[diag];
     for(count=0;count<diag_count[diag];count++) {
       location=position+count;
       new_color=l_diag[location].color;
       if(new_color==color) {
	 new_row=l_diag[location].row;
	 column=l_diag[location].column;
	 if(column>=dis_t) {
	   for(row=new_row; row<(new_row+l_diag[location].length);row++) {
	     if((column>=dis_t) && (column<=dis_b) && (row>=dis_l)
		&& (row<= dis_r)) {
	       if(((prob_annotation_flag)||(annotation_flag)) &&(color==0)) {
		 ann_color=get_ann_color(row,column);
		 color_index = color_ann[ann_color];
		 if(dot_lower_flag)
		   img_plot_dot(x_start, y_start, x_pic_per_dot, y_pic_per_dot,
				dis_t, dis_l, color_index, row, column);
		 else
		   img_plot_dot(x_start, y_start, x_pic_per_dot, y_pic_per_dot,
				dis_l, dis_t, color_index, column,row);
	       } else {
		 if(((comp_flag)&&(color==0))&&check_compensate(row,column)) {
		   if(dot_lower_flag)
		     img_plot_dot(x_start, y_start, x_pic_per_dot, 
				  y_pic_per_dot, dis_t, dis_l, color_co,
				  row, column);
		   else
		     img_plot_dot(x_start, y_start, x_pic_per_dot, 
				  y_pic_per_dot, dis_l, dis_t, color_co,
				  column, row);
		 } else {
		   if(dot_lower_flag)
		     img_plot_dot(x_start, y_start, x_pic_per_dot, 
				  y_pic_per_dot, dis_t, dis_l, color_index,
				  row, column);
		   else
		     img_plot_dot(x_start, y_start, x_pic_per_dot,
				  y_pic_per_dot, dis_l, dis_t, color_index,
				  column, row);
		 }
	       } 
	     }
	     column--;
	   }
	 }
       }
     }
   }
 }
 /* draw unique dots */
 if(unique_mode) {
   holder = malloc( (int) (1.5*sequence_length+1)*sizeof(int));
   if(holder==NULL) {
     printf("Error!\tInsufficient memory for unique dots ");
     printf("in plot_points_unique of %s\n", PROGRAM_NAME);
     try_exit(27);
   }
   size=(int)(1.5*sequence_length+1);
   for(row=0; row<(size-1); row++)
     holder[row]=0; 
   color=2;
   color_index = *img_color[color];
   /* set black,gray */
   for(diag=start_diag;diag<=end_diag;diag++) { 
     /* set black,gray */
     position = diag_start[diag];
     for(count=0;count<diag_count[diag];count++) {
       location=position+count;
       if(l_diag[location].color<2) {
	 new_row=l_diag[location].row;
	 column=l_diag[location].column;
	 if((new_row<=dis_b)&&(column>=dis_l)) {
	   for(row=new_row;row<new_row+l_diag[location].length;row++) {
	     if((row>=dis_t)&&(row<=dis_b)&&(column>=dis_l)&&(column<=dis_r)) {
	       holder[row]=1;
	     }
	     column--;
	   }
	 }
       }
     }
     /* plot other colors */
     for(count=0;count<diag_count[diag];count++) {
       location=position+count;
       if((l_diag[location].row<=dis_b)&&(l_diag[location].column>=dis_l)) {
	 if(l_diag[location].color>1)
	   for(row = l_diag[location].row, column = l_diag[location].column;
	       row<l_diag[location].row+l_diag[location].length; row++) {
	     if((row>=dis_t)&&(row<=dis_b)&&(column>=dis_l)&&(column<=dis_r)) {
	       if(holder[row]==0) {
		 if(color!=l_diag[location].color) {
		   color=l_diag[location].color;
		   color_index = *img_color[color];
		 }
		 if(dot_lower_flag)
		   img_plot_dot(x_start, y_start, x_pic_per_dot, y_pic_per_dot,
				dis_t, dis_l, color_index, column, row);
		 else
		   img_plot_dot(x_start, y_start, x_pic_per_dot, y_pic_per_dot,
				dis_l, dis_t, color_index, row, column);
	       }
	     }
	     column--;
	   }
       }
     }
     /* zero out black,gray */
     for(count=0;count<diag_count[diag];count++) {           
       location=position+count;
       if(l_diag[location].color<2) {
	 new_row = l_diag[location].row;
	 column = l_diag[location].column;
	 if((new_row<=dis_b)&& (column>=dis_l)) { 
	   for(row=new_row;row<new_row+l_diag[location].length;row++) {
	     if((row>=dis_t)&&(row<=dis_b)&&(column>=dis_l)&&(column<=dis_r)) {
	       holder[row]=0;
	     }
	     column--;
	   }
	 }
       }
     }
   }	
   free(holder);
 }
}

/* make diagonal line */
void img_make_diag(int dis_l,int dis_r,int dis_t,int dis_b,int  x_start,
		   int start_y,float x_pic_per_dot,float y_pic_per_dot) {
  int ty, rx, lx, by, right, top, left, bottom;
  if(!((dis_r>=dis_l)&&(dis_b>=dis_l)))
    return; /* There is no diagonal line */
  /* find right end of line */
  if(dis_r>dis_b) { /* diagonal crosses bottom border */
    bottom = dis_b;
    right = bottom;
  } else { /* diagonal crosses right border */
    right = dis_r;
    bottom = right;
  }
  /* find left end of line */
  if(dis_l>dis_t) { /* diagonal crosses left side */
    left = dis_l;
    top = dis_l;
  } else { /* diagonal crosses top side */
    top = dis_t;
    left = top;
  }
  ty = img_row_to_y(dis_t, start_y, y_pic_per_dot, top) -
    (int)(y_pic_per_dot/2.+.5);
  lx = img_row_to_y(dis_l,x_start,x_pic_per_dot,left) -
    (int)(x_pic_per_dot/2.+.51);
  rx = img_col_to_x(dis_l,x_start,x_pic_per_dot,right) +
    (int)(x_pic_per_dot/2.+.51);
  by = img_row_to_y(dis_t,start_y,y_pic_per_dot,bottom) +
    (int)(y_pic_per_dot/2.+.5);
  gdImageLine(image, lx - 1, ty - 1, rx, by, color_tx);
} 

void img_label_points(int x_start, int y_start, float x_pic_per_dot,
		      float y_pic_per_dot, int dis_l, int dis_t, 
		      int zoom_labels_count, int *zoom_labels_row,
		      int *zoom_labels_col) {
  int i, hor_pos, ver_pos, label_hor_pos, lx, ty, rx, by, hor_shift, ver_shift;
  char string[80];
  hor_shift = (int)(x_pic_per_dot/3);
  ver_shift = (int)(y_pic_per_dot/3);
  for(i=0;i<zoom_labels_count;i++) {
    hor_pos = img_col_to_x(dis_l, x_start, x_pic_per_dot, zoom_labels_col[i]);
    ver_pos = img_row_to_y(dis_t, y_start, y_pic_per_dot, zoom_labels_row[i]);
    label_hor_pos = img_col_to_x(dis_l, x_start, x_pic_per_dot,
				 zoom_labels_col[i]+1);
    lx = hor_pos - hor_shift;
    rx = hor_pos + hor_shift;
    ty = ver_pos - ver_shift;
    by = ver_pos + ver_shift;
    strcpy(string,num_string_int(zoom_labels_row[i]));
    strcat(string,",");
    strcat(string,num_string_int(zoom_labels_col[i]));
    gdImageFilledRectangle(image, lx, ty, rx, by, color_lb);
    gdImagePrintf(image, gdFontSmall, label_hor_pos + 1, ver_pos - 5, 
		  color_lb, "<%s> ", string);
  }
}

int convert(float color) {
  return (int)(255*color);
}

int open_img(char *img_filename) { /* open specified output file */
  if ((giffp = fopen(img_filename, "w")) == NULL) { /* open a file */
    printf ("Error!\tCould not open file: %s\n", img_filename);
    return(1);
  }
  return (0);
}

void finish_making_img(char *img_filename, int dis_l, int dis_r, int dis_t, 
		       int dis_b, int grid_flag, int *diag_start,
		       int *diag_count, int count_nearby, int unique_mode,
		       struct helix *l_diag, struct basepair *nearby_basepair,
		       int last_used_sequence, int comp_flag, 
		       int sequence_length, int zoom_comp, 
		       int zoom_labels_count, int *zoom_labels_row, 
		       int *zoom_labels_col, float color_a[][3],
		       int img_resolution, int chain_len, 
		       char sequence_name[TOTAL_SEQUENCES][120], 
		       int count_sequences, int *worst_energy,
		       int *optimal_energy, int *energy_cutoff,
		       int points_plotted_zoom, int points_plotted_zoom_all,
		       int no_partial_flag, int annotation_flag,
		       int prob_annotation_flag, float ann_color[][3],
		       int number_ann_colors, int dot_lower_flag,
		       int png_mode,int jpg_mode) {
  int i;
  int error; /* resoulution is 72, 110, or 200 ? */
  int resolution;
  char string[80];
  char temp_img_filename[120];
  int seq; 
  /* use 8.5 wide by 11 inches wide gif ? */
  int img_width; /* width of image in pixels */
  int img_height; /* height of image in pixels */
  int lx,ty,rx,by; /* top,bottom,right,left corn of rec */
  float x_pic_per_dot,y_pic_per_dot;
  char type_string[8];
  int x_start,y_start;
  int y_pos;
  printf("\n left=%d right=%d top=%d, bottom=%d", dis_l,dis_r,dis_t,dis_b);
  resolution=img_resolution;
  img_width=(int)(8.5*resolution)-1;
  img_height=11*resolution-1; 
  strcpy(temp_img_filename,img_filename);
  if(png_mode)
    strcpy(type_string,"png");
  else if(jpg_mode)
    strcpy(type_string,"jpg");
  else
    strcpy(type_string,"gif");
  error=open_img(img_filename);
  if(error) {
    printf("Error creating %s file\n",type_string);
    return;
  }                                 /* hor by ver or x by y */
  image = gdImageCreate(img_width + 1, img_height + 1);
  /* declare image size in pixels */ 
  printf("Creating %s %d by %d\n",type_string, img_width+1,img_height+1);
  /* declare colors, first is background */
  for(i=11;i>=0;i--) {
    *img_color[i] = gdImageColorAllocate(image, convert(color_a[i][0]),
					 convert(color_a[i][1]),
					 convert(color_a[i][2]));
  }
  *img_color[12] = gdImageColorAllocate(image, convert(color_a[12][0]),
					convert(color_a[12][1]),
					convert(color_a[12][2]));
  if((annotation_flag)||(prob_annotation_flag)) {
    for(i=0;i<number_ann_colors;i++)
      color_ann[i] = gdImageColorAllocate(image, convert(ann_color[i][0]),
					  convert(ann_color[i][1]),
					  convert(ann_color[i][2]));
  }
  if(!jpg_mode)  
    gdImageInterlace(image, 1);  /* turn on interlace */
  /* make box 7x7 in^2 */
  ty = (int)(1.97*resolution); /* come down 3 inches */
  by = (int)(img_height-1.97*resolution);
  lx = (int)(.47*resolution); /* left side of box */ 
  rx = img_width-(.95*resolution); /* 6.5 inches wide drawing region*/
  /* an extra .1 inch was used to make the line outside the region */
  gdImageRectangle(image, lx, ty, rx, by, *img_color[COLOR_TEXT]);
  gdImageString(image, gdFontGiant, 4 * resolution - 40,
		(int) (resolution / 4), (unsigned char*) PROGRAM_NAME" ", 
		*img_color[COLOR_TEXT]);
  x_pic_per_dot = resolution*7.0/(dis_r-dis_l+1);
  /* width of base pair*/
  y_pic_per_dot = resolution*7.0/(dis_b-dis_t+1); /* height of base pair*/
  x_start=(int)(.5*resolution+x_pic_per_dot/2+.5);
  /* distance from left edge for first base pair*/
  y_start=(int)(2.0*resolution+y_pic_per_dot/2+.5);
  /* distance from top for first base pair
   * both above are in pixels
   * create the tic marks */
  img_tics(x_start,y_start,x_pic_per_dot,y_pic_per_dot,dis_l,
	   dis_r,dis_t,dis_b,lx,rx,ty,by,grid_flag);
  /* make the diagonal line */
  img_make_diag(dis_l, dis_r, dis_t, dis_b, x_start, y_start, x_pic_per_dot,
		y_pic_per_dot);
  /* create the points */
  img_points(x_start, y_start, x_pic_per_dot, y_pic_per_dot, dis_l, dis_r,
	     dis_t, dis_b, diag_start, diag_count, count_nearby,
	     unique_mode, l_diag, nearby_basepair, last_used_sequence,
	     comp_flag, sequence_length, no_partial_flag, annotation_flag,
	     prob_annotation_flag, dot_lower_flag);
  gdImagePrintf(image, gdFontLarge, (int) (.5 * resolution), resolution, 
		*img_color[COLOR_TEXT], "Base pairs: %d", points_plotted_zoom);
  gdImagePrintf(image, gdFontLarge, (int) (2.6 * resolution), resolution,
		*img_color[COLOR_TEXT], "Common Base pairs: %d", 
		points_plotted_zoom_all);
  if(chain_len>1)
    gdImagePrintf(image, gdFontLarge, (int) (5.4 * resolution), 
		  resolution, *img_color[COLOR_TEXT], "Filter: %d", chain_len);
  y_pos = (int)(9.05*resolution);
  by = y_pos+15;
  if(g_prob==TRUE) {
    gdImageString(image, gdFontLarge, (int) (resolution / 2), y_pos, 
		  (unsigned char*) "Names   ", color_tx);
    gdImageString(image, gdFontLarge, (int) (3.7 * resolution), y_pos,
		  (unsigned char*) "Range ", color_tx);
    gdImageString(image, gdFontLarge, (int) (4.8 * resolution), y_pos,
		  (unsigned char*) "Cutoff ", color_tx);
    gdImageLine(image, lx, by, rx, ty, color_tx);
    y_pos = (int)(9.25*resolution);
    gdImageString(image, gdFontLarge, (int) (resolution / 2), y_pos + 1, 
		  (unsigned char*) sequence_name[0], color_tx);
  } else {
    gdImageString(image, gdFontLarge, (int) (resolution / 2), y_pos, 
		  (unsigned char*) "Names     Energies in kcal/mol", color_tx);
    gdImageString(image, gdFontLarge, (int) (4.1 * resolution), y_pos, 
		  (unsigned char*) "Optimal", color_tx);
    gdImageString(image, gdFontLarge, (int) (5.1 * resolution), y_pos, 
		  (unsigned char*) " ddG", color_tx);
    gdImageLine(image, lx, by, rx, by, color_tx);
    y_pos = (int)(9.25*resolution);
    gdImageString(image, gdFontLarge, (int) (resolution / 2), y_pos + 1, 
		  (unsigned char*) sequence_name[0], color_bk);
  }
  if(count_sequences>2) {
    y_pos=(int)(9.25*resolution+resolution/4);
    gdImageString(image, gdFontLarge, (int) (resolution / 2), y_pos, 
		  (unsigned char*) sequence_name[1], color_gy);
  }  
  if(g_prob==TRUE) {  
    for(seq=2;seq<=last_used_sequence;seq++) {
      y_pos = (int)(9.25*resolution+seq*resolution/4);
      gdImageString(image, gdFontLarge, (int) (resolution / 2), y_pos,
		    (unsigned char*) sequence_name[seq], *img_color[seq]);
      strcpy(string,num_string_fancy_int(worst_energy[seq]));
      strcat(string," to ");
      strcat(string,num_string_fancy_int(optimal_energy[seq]));
      gdImageString(image, gdFontLarge, (int) (3.4 * resolution), 
		    y_pos, (unsigned char*) string, color_tx);
      strcpy(string,num_string_fancy_int(energy_cutoff[seq])); 
      gdImageString(image, gdFontLarge, (int) (5.1 * resolution), 
		    y_pos, (unsigned char*) string, color_tx);
    }
  } else {  
    for(seq=2;seq<=last_used_sequence;seq++) {
      y_pos = (int)(9.25*resolution+seq*resolution/4);
      gdImageString(image, gdFontLarge, (int) (resolution / 2), y_pos, 
		    (unsigned char*) sequence_name[seq], *img_color[seq]);
      strcpy(string,num_string_fancy_int(energy_cutoff[seq]-
					 optimal_energy[seq]));
      gdImageString(image, gdFontLarge, (int) (4.8 * resolution), y_pos, 
		    (unsigned char*) string, color_tx);
      strcpy(string,num_string_fancy_int(optimal_energy[seq]));
      gdImageString(image, gdFontLarge, (int) (4. * resolution), y_pos, 
		    (unsigned char*) string, color_tx);
    }
  }
  if(comp_flag)
    gdImagePrintf(image, gdFontLarge, (int) (6 * resolution), (int) 
		  (9.25 * resolution), color_co, "Compensate: %d", zoom_comp);
  /* make and label the labeled dots */ 
  if(zoom_labels_count>0)
    img_label_points(x_start,y_start,x_pic_per_dot,y_pic_per_dot,dis_l,dis_t,
		     zoom_labels_count,zoom_labels_row,zoom_labels_col);
  if (png_mode)
#if HAVE_GDIMAGEPNG
    gdImagePng(image, giffp)
#endif
      ;
  else if (jpg_mode)
#if HAVE_GDIMAGEJPEG
    gdImageJpeg(image, giffp, -1)
#endif
      ;
  else
#if (defined(HAVE_LIBGD) || defined(HAVE_GDIMAGECREATE)) && defined(HAVE_GD_H)
    gdImageGif(image, giffp)
#endif
      ;
  fclose(giffp);
  printf("%s  file: %s\n",type_string, img_filename); 
}  
