void report_mem_error(char *string) {
	printf("Error!\tInsufficient memory to allocate %s.", string);
	try_exit(22);
}

/* May 8, 2014. M. Zuker replaces malloc with calloc. Reason: Bug when
   reading ss file where the last base is paired. In this case,
   b_2 = g_connected["last base"] had a garbage value (a very large int)
   which caused a segmentation fault when, for example, g_base_y[b_2] was
   accessed. */
void memory_allocator(int length) {
  int             size, size2;
  size = length + 4;
  size2 = length + 3;
  
  g_base_x = (float *) calloc(size, sizeof(float)) ;
  if (g_base_x == NULL)
    report_mem_error("g_base_x");
  g_base_y = (float *) calloc(size, sizeof(float)) ;
  if (g_base_y == NULL)
    report_mem_error("g_base_y");
  g_structure_angle = (float *) calloc(size, sizeof(float)) ;
  if (g_structure_angle == NULL)
    report_mem_error("g_structure_angle");
  g_structure_label_x = (float *) calloc(size, sizeof(float)) ;
  if (g_structure_label_x == NULL)
    report_mem_error("g_structure_label_x");
  g_structure_label_y = (float *) calloc(size, sizeof(float)) ;
  if (g_structure_label_y == NULL)
    report_mem_error("g_structure_label_y");
  
  g_structure_label_value = (int *) calloc(size, sizeof(int)) ;
  if (g_structure_label_value == NULL)
    report_mem_error("g_structure_label_value");
  g_history = (int *) calloc(size, sizeof(int)) ;
  if (g_history == NULL)
    report_mem_error("g_history");
  /* 2003-06-21 Nick Markham start */
  g_next = (int *) calloc(size, sizeof(int)) ;
  if (g_next == NULL)                        
    report_mem_error("g_next") ; 
    g_prev = (int *) calloc(size, sizeof(int));
  if (g_prev == NULL)                          
    report_mem_error("g_prev"); 
  /* 2003-06-21 Nick Markham end */
    g_undo1_base_x = (float *) calloc(size, sizeof(float)) ;
  if (g_undo1_base_x == NULL)
    printf("Insufficient memory to allocate g_undo1_base_x\n");
  g_undo1_base_y = (float *) calloc(size, sizeof(float)) ;
  if (g_undo1_base_y == NULL)
    report_mem_error("g_undo1_base_y");
  g_undo1_structure_angle = (float *) calloc(size, sizeof(float)) ;
  if (g_undo1_structure_angle == NULL)
    report_mem_error("g_undo1_structure_angle");
  g_undo2_base_x = (float *) calloc(size, sizeof(float)) ;
  if (g_undo2_base_x == NULL)
    printf("Insufficient memory to allocate g_undo2_base_x\n");
  g_undo2_base_y = (float *) calloc(size, sizeof(float)) ;
  if (g_undo2_base_y == NULL)
    report_mem_error("g_undo2_base_y");
  g_undo2_structure_angle = (float *) calloc(size, sizeof(float)) ;
  if (g_undo2_structure_angle == NULL)
    report_mem_error("g_undo2_structure_angle");
  
  g_previous_loop = (int *) calloc(size, sizeof(int)) ;

  if (g_previous_loop == NULL)
    report_mem_error("g_previous_loop");
  
  g_ss_code = (int *) calloc(size, sizeof(int)) ;
  if (g_ss_code == NULL)
    report_mem_error("g_ss_code");
  g_connected = (int *) calloc(size, sizeof(int));
  if (g_connected == NULL)
    report_mem_error("g_connected");
  g_oldconnect = (int *) calloc(size, sizeof(int)) ;
  if (g_oldconnect == NULL)
    report_mem_error("g_oldconnect");
  g_bases = (char *) calloc(size, sizeof(char)) ;
  if (g_bases == NULL)
    report_mem_error("g_bases");
  g_base_list = (int *) calloc(size, sizeof(int)) ;
  if (g_base_list == NULL)
    report_mem_error("g_base_list");
  g_base_advance = (float *) calloc(size, sizeof(float)) ;
  if (g_base_advance == NULL)
    report_mem_error("g_base_advance");
  
  g_loop_center_x = (float *) calloc(size, sizeof(float)) ;
  if (g_loop_center_x == NULL)
    report_mem_error("g_loop_center_x");
  
g_loop_center_y = (float *) calloc(size, sizeof(float)) ;
  if (g_loop_center_y == NULL)
    report_mem_error("g_loop_center_y");
g_undo1_loop_center_x = (float *) calloc(size, sizeof(float)) ;
  if (g_undo1_loop_center_x == NULL)
    report_mem_error("g_undo1_loop_center_x");
g_undo1_loop_center_y = (float *) calloc(size, sizeof(float)) ;
  if (g_undo1_loop_center_y == NULL)
    report_mem_error("g_undo1_loop_center_y");
g_undo2_loop_center_x = (float *) calloc(size, sizeof(float)) ;
  if (g_undo2_loop_center_x == NULL)
    report_mem_error("g_undo2_loop_center_x");
g_undo2_loop_center_y = (float *) calloc(size, sizeof(float)) ;
  if (g_undo2_loop_center_y == NULL)
    report_mem_error("g_undo2_loop_center_y");
  
g_loop_radius = (float *) calloc(size, sizeof(float)) ;
  if (g_loop_radius == NULL)
    report_mem_error("g_loop_radius");
  
g_stack = (int *) calloc(size, sizeof(int)) ;
  if (g_stack == NULL)
    report_mem_error("g_stack");
  
g_midpoint_x = (float *) calloc(size, sizeof(float)) ;
  if (g_midpoint_x == NULL)
    report_mem_error("g_midpoint_x");
g_midpoint_y = (float *) calloc(size, sizeof(float)) ;
  if (g_midpoint_y == NULL)
    report_mem_error("g_midpoint_y");
  
g_ann_to_color = (int *) calloc(size, sizeof(int)) ;
  if (g_ann_to_color == NULL)
    report_mem_error("g_ann_to_color");
}
